Page({
  data: {
    name: wx.getStorageSync('username'),
    avatar: wx.getStorageSync('avatar'),
    role: wx.getStorageSync('role'),
    current: 1,
    list: [{
      id: 1,
      text: '修改密码',
      imgUrl: 'http://resource.weilaigo.l4j.cn/bike_yunwei/pwd.png'
    },
    {
      id: 2,
      text: '地勤人员',
      imgUrl: 'http://resource.weilaigo.l4j.cn/bike_yunwei/worker.png'
    },
    {
      id: 7,
      text: '用户反馈',
      imgUrl: 'http://resource.weilaigo.l4j.cn/yunwei/feedBack.png'
    },
    {
      id: 8,
      text: '用户报修',
      imgUrl: 'http://resource.weilaigo.l4j.cn/yunwei/repair.png'
    },
    {
      id: 3,
      text: '中控管理',
      imgUrl: 'http://resource.weilaigo.l4j.cn/yunwei/control.png'
    },
    {
      id: 4,
      text: '数据统计',
      imgUrl: 'http://resource.weilaigo.l4j.cn/yunwei/statistics.png'
    },
    // {
    //   id: 5,
    //   text: '热力地图',
    //   imgUrl: 'http://resource.weilaigo.l4j.cn/yunwei/hot.png'
    // },
    {
      id: 6,
      text: '停车区管理',
      imgUrl: 'http://resource.weilaigo.l4j.cn/bike_yunwei/parkMange.png'
    },

    ],
    areaList: [],//区域列表
    areaIndex: '',//选中区域下标
  },
  onLoad: function () {
    console.log(wx.getStorageSync('allArea'))
    let allArea = wx.getStorageSync('allArea')
    this.setData({
      areaList: allArea
    })
  },
  //热力地图选择区域
  bindPickerChange: function (e) {
    let index=e.detail.value
    let areaId=this.data.areaList[index].areaID
    wx.navigateTo({
      url:'/pages/chart/chart?area_id=' + areaId
    })
  },
  scanCode: function () {
    wx.redirectTo({
      url: '/pages/logs/logs?scan=' + 1,
    })
  },
  skipNext(e) {
    let idx = e.currentTarget.dataset.id;
    let url = '';
    switch (idx) {
      case 1:
        url = "/pages/password/password";
        break;
      case 2:
        url = "/pages/personnel/personnel";
        break;
      case 3:
        url = "/pages/control/control";
        break;
      case 4:
        url = "/pages/lineChart/lineChart";
        break;
      // case 5: //热力地图
      //   url = "/pages/chart/chart";
      //   break;
      case 6:
        url = "/pages/park/park";
        break;
      case 7:
        url = "/pages/feedback/feedback";
        break;
      case 8:
        url = "/pages/repairs/repairs";
        break;
      default:
        break;
    }
    wx.navigateTo({
      url
    })
  },
  //退出登录
  quit() {
    wx.removeStorageSync('username');
    wx.removeStorageSync('avatar');
    wx.removeStorageSync('token');
    wx.removeStorageSync('role');
    wx.removeStorageSync('curVal');
    wx.removeStorageSync('curId');
    wx.redirectTo({
      url: '/pages/login/login',
    })
  },
  onShow: function () {
    this.setData({
      name: wx.getStorageSync('username'),
      avatar: wx.getStorageSync('avatar'),
      role: wx.getStorageSync('role'),
    })
  },
  onShareAppMessage: function () {
    return {
      title: '轻松出行，方便你我',
      path: '/pages/login/login',
      success: function (res) { }
    }
  }
})